﻿using Syncfusion.WinForms.Controls;
using Syncfusion.WinForms.DataGrid.Styles;
using System.Windows.Forms;
using Syncfusion.WinForms.DataGrid.Enums;
using Syncfusion.WinForms.DataGrid.Interactivity;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.WinForms.DataGrid.Renderers;
using System.Text.RegularExpressions;
using System;
using System.Linq;
using Syncfusion.WinForms.GridCommon.ScrollAxis;
using System.Drawing;
using Syncfusion.Data;
using System.Collections.ObjectModel;
using Syncfusion.WinForms.DataGrid.Data;
using System.Collections.Generic;
using Syncfusion.WinForms.DataGrid.Helpers;
using System.Windows.Forms.VisualStyles;
using Syncfusion.WinForms.DataGrid.Styles;
using Syncfusion.WinForms.DataGrid.Helpers;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.WinForms.DataGrid.Enums;
using Syncfusion.WinForms.DataGrid.Events;
using Syncfusion.WinForms.Core;
using Syncfusion.WinForms.Core.Enums;
using System.Reflection;
using System.Data;

namespace UpdateMasterExcelDocument
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();

            sfDataGrid1.AutoGenerateColumns = false;
            sfDataGrid1.ShowRowHeader = true;
            sfDataGrid1.AutoSizeColumnsMode = AutoSizeColumnsMode.AllCells;
            sfDataGrid1.Columns.Add(new GridImageColumn() { MappingName = "Flag" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "DocumentName" });
            sfDataGrid1.Columns.Add(new GridTextColumn() { MappingName = "TabName" });
            sfDataGrid1.Columns.Add(new GridNumericColumn() { MappingName = "RowsTransported" });
            sfDataGrid1.Columns.Add(new GridCheckBoxColumn() { MappingName = "Successful" });

            this.sfDataGrid1.Columns["Flag"].AllowGrouping = true;
            this.sfDataGrid1.Columns["DocumentName"].AllowGrouping = true;
            this.sfDataGrid1.Columns["TabName"].AllowGrouping = true;
            this.sfDataGrid1.Columns["RowsTransported"].AllowGrouping = true;
            this.sfDataGrid1.Columns["Successful"].AllowGrouping = true;

            //this.sfDataGrid1.GroupColumnDescriptions.Add(new GroupColumnDescription() { ColumnName = "DocumentName" });

            VerwerkingsInfoCollection infoCollection = new VerwerkingsInfoCollection();
            sfDataGrid1.DataSource = infoCollection.Info;

            this.sfDataGrid1.DrawCell += sfDataGrid_DrawCell;

            sfDataGrid1.TableControl.RowHeights[0] = 50;
        }

        void sfDataGrid_DrawCell(object sender, DrawCellEventArgs e)
        {
            if (e.DataRow.RowType != RowType.HeaderRow && e.ColumnIndex == 1)
            {
                SfDataGrid sfDataGrid = (SfDataGrid)sender;
                var dataSource = (List<VerwerkingsInfo>)sfDataGrid.DataSource;

                foreach (VerwerkingsInfo info in dataSource)
                {
                    e.Handled = true;
                    e.Graphics.DrawImage(info.Flag, new Rectangle(e.Bounds.X + 50, e.Bounds.Y + 2, e.Bounds.Width - 100, e.Bounds.Height - 5));
                    //e.Graphics.DrawString(e.DisplayText, e.Style.GetFont(), new SolidBrush(e.Style.TextColor), new RectangleF(e.Bounds.X + 500, e.Bounds.Y + 10, e.Bounds.Width, e.Bounds.Height - 5));
                    Pen borderPen = new Pen(Color.LightGray);
                    e.Graphics.DrawLine(new Pen(e.Style.Borders.Right.Color), e.Bounds.Right - 1, e.Bounds.Top, e.Bounds.Right - 1, e.Bounds.Bottom);
                    e.Graphics.DrawLine(new Pen(e.Style.Borders.Bottom.Color), e.Bounds.Left, e.Bounds.Bottom - 1, e.Bounds.Right, e.Bounds.Bottom - 1);
                }
            }
        }
    }
}
